;--------------------------------------------;
;   TENTO PROGRAM DEMONSTRUJE ROZPOZNAVANI   ;
;  NAUCENEHO KODU, VZOR JE UKLADAN DO FLASH  ;
;  PAMETI.                                   ;
;  NAVIC JSOU POUZITY ZOBRAZOVACI SKRIPTY!!! ;
;   Vystup je posilan na seriovy port, ale   ;
;   soucasne je videt indikace na displeji.  ;
;--------------------------------------------;

	LIST	P = 16F877, R = DEC
	#include	p16f877.inc

	__CONFIG	B'11111100111010'

	#include	displej.inc
	#include	unibuff.inc
	#include	intervl2.inc
	#include	ir_rec2.inc
	#include	flash.inc
	#include	tab_util.inc
	#include	dskripty.inc
	#include	div16u.inc

;---------------------------------------------
; KONSTANTY PROGRAMU

MINPULZ	EQU	D'150'	; maximalni delka jednoznacne poruchy

BLOK1	EQU	H'110'	; adresa zaznamu v RAM pameti (prvni byty)
BLOK2	EQU	H'190'	; adresa zaznamu v RAM pameti (druhe byty)
CK_ADR	EQU	D'2148'	; adresa zaznamu ve FLASH pameti
BUFF_SIZE	EQU	D'64'	; velikost prijimaciho IR-bufferu

MINKOD	EQU	D'6'	; minimalni pripustna delka kodu
MAXKOD	EQU	D'64'	; maximalni pripustna delka kodu

ADIT_CH	EQU	D'25'	; aditivni chyba (viz. tolerancni interval)

#DEFINE	DB4	PORTE,2	; piny pro ovladani displeje
#DEFINE	DB5	PORTE,1
#DEFINE	DB6	PORTE,0
#DEFINE	DB7	PORTA,4
#DEFINE	E	PORTB,1
#DEFINE	RW	PORTB,2
#DEFINE	RS	PORTB,3


OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"
TEMPRAM	EQU	H'70'	; posledni blok pameti (16 bytu)
			; - je zrcadlen do vsech pametovych bank

	CBLOCK	OFFRAM
	TML:1	; pro obsluhu displeje
	TMH:1
	DDATA:1

	BUFF_IN:1	; pro obsluhu bufferu
	BUFF_OUT:1
	BUFF_STAT:1
	BUFF_TEMP:1
	BUFF_ADR:BUFF_SIZE

	POZICE:1	; pro zaznam kodu do RAM
	KOD:2
	I1:2
	I2:2

	K_ADR:2	; promenna flash adresa

	AA:2	; pro skripty
	BB:2
	CC:2
	VD16U:1 
	NUMFORM_:1
	ENDC

	CBLOCK	TEMPRAM	; zalozni registry, ktere
	W_TEMP:1		; jsou nezavisle na zvolene
	ST_TEMP:1		; pametove bance !!!
	FSR_TEMP:1
	ENDC

;------------------------------------------------	
; RESET / START

	ORG	0
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	GOTO	START

;------------------------------------------------
; OBSLUHA PRERUSENI

	ORG	4
	MOVWF	W_TEMP		; zaloha registru W,STATUS a FSR
	MOVF	STATUS,W
	MOVWF	ST_TEMP
	MOVF	FSR,W
	MOVWF	FSR_TEMP
	banksel	0
	BTFSS	PIR1,TMR1IF	; pokud doslo k preteceni casovace
	GOTO	RB_INT
	MOVLW	D'0'	; ulozime do bufferu nulovou hodnotu (16 bitu)
	CALL	IN_BUFF
	MOVLW	D'0'
	CALL	IN_BUFF
	banksel	PIE1	; nasledne zakazeme dalsi preruseni od casovace
	BCF	PIE1,TMR1IE
	banksel	0
RB_INT	BTFSS	INTCON,RBIF	; testujeme preruseni od optoprijimace
	GOTO	INT_END
	MOVF	PORTB,F		; "refresujeme" porovnavaci registr
	BCF	INTCON,RBIF	; vynulujeme priznak
	BCF	T1CON,TMR1ON	; zastavime TMR1
	banksel	PIE1
	BSF	PIE1,TMR1IE	; povolime prerusemi od casovace
	banksel	PIR1
	BTFSS	PIR1,TMR1IF	; pokud TMR1 pretekl,...
	GOTO	VYSLI_H
	CLRF	TMR1H		; ..., potom jej vynulujeme
	CLRF	TMR1L
	BCF	PIR1,TMR1IF
VYSLI_H	MOVF	TMR1H,W		; vyssi byte TMR1 vlozime do bufferu
	CALL	IN_BUFF
	MOVF	TMR1H,F		; pokud je vyssi byte nulovy,...
	BTFSS	STATUS,Z
	GOTO	SKOK
	MOVF	TMR1L,W		; ...potom testujeme zda je nulova
	BTFSC	STATUS,Z
	GOTO	SKOK
	SUBLW	MINPULZ		; pokud neni nulova,...
	BTFSS	STATUS,C		; ...testujeme, zda neni prilis mala
	GOTO	SKOK
	CLRF	TMR1L		; pokud je nenulova, ale mala,...
	BSF	PIR1,TMR1IF	; ...potom predstirame chybu v budoucim mereni
SKOK	MOVF	TMR1L,W		; zde vkladame nizsi byte TMR1 do bufferu
	CALL	IN_BUFF
	CLRF	TMR1H		; nulujeme TMR1
	CLRF	TMR1L
	BSF	T1CON,TMR1ON	; TMR1 je spusten

INT_END	MOVF	FSR_TEMP,W	; obnova registru ze zalohy
	MOVWF	FSR
	MOVF	ST_TEMP,W
	MOVWF	STATUS
	SWAPF	W_TEMP,F
	SWAPF	W_TEMP,W
	RETFIE

;-------------------------------------
; INICIALIZACE
	
START	
	banksel	TRISB
	BCF	TRISB,4	; musi byt nastaveno jako vystup
	BCF	TRISB,5
	BCF	TRISB,6
	BSF	TRISB,7	; sem je pripojen optoprijimac
	MOVLW	B'00100100'	; nastav vysilac pro...
	banksel	TXSTA		; ...asynchronni 8bitovy prenos
	MOVWF	TXSTA
	MOVLW	B'10010000'	; nastav prijimac pro...
	banksel	RCSTA		; ...asynchronni 8bitovy prijem
	MOVWF	RCSTA
	MOVLW	D'64'		; nastav komunikacni rychlost,...
	banksel	SPBRG		; ...v nasem pripade 19200 baudu
	MOVWF	SPBRG
	banksel	ADCON1
	MOVLW	B'00000110'	; nastav PORTA a PORTE jako "logicky"
	MOVWF	ADCON1
	banksel	0
	
	; inicializace bufferu
	BUFFINI 	BUFF_IN, BUFF_OUT,BUFF_STAT

	banksel	T1CON	; nastaveni TMR1 (predelicka 1:4);
	MOVLW	B'00101101'
	MOVWF	T1CON

	; inicializace displeje
	CALL	INITDISP
	; napis: "vygenerujte novy IR-kod"
	MOVLW	D'0'
	CALL	SKRIPT

	BSF	INTCON,RBIE	; povoleno preruseni od optoprijimace
	BSF	INTCON,PEIE	; povoleno preruseni od nektere periferie (v tomto pripade TMR1)
	BSF	INTCON,GIE	; aktivace systemu preruseni

;----------------------------------------------
; HLAVNI PROGRAM


	CLRF	POZICE	; ukazatel do zaznamu je nastaven na prvni polozku
LOOP	MOVF	BUFF_STAT,F
	BTFSC	STATUS,Z	; pokud je v bufferu hodnota,... 
	GOTO	LOOP
	CALL	OUT_BUFF	; ...ulozime ji do promenne KOD
	MOVWF	KOD+1
	CALL	OUT_BUFF
	MOVWF	KOD
	KRATIT_14	KOD	; !!!zkraceni KODu na 14 bitu!!!
	CALL	IR_REC	; volame zaznamenavaci podprogram
	BTFSS	STATUS,C	; je zaznam hotov?
	GOTO	LOOP	; - pokud ne, opakujeme cyklus

	; zde je do promenne ukladana konstantni adresa...
	; pouziti promenne tady sice nema smysl, ale uplatni
	; se to v pristi verzi programu
	MOVLW	CK_ADR % D'256' ; urceni FLASH adresy pro zapis
	MOVWF	K_ADR
	MOVLW	CK_ADR / D'256'
	MOVWF	K_ADR+1
	; kopirovani zaznamu z RAM do FLASH
	SAVE_REC_	KOD, POZICE, BLOK1, BLOK2, K_ADR

	CLRF	POZICE	; - pokud ano, cyklus konci a zahajime cteni zaznamu nastavenim ukazatele na prvni polozku
READING	CALL	FLRD_REC	; precteme aktualni polozku ze zaznamu (z FLASH pameti)
	MOVF	KOD,F	; testujeme, zda to neni nula...
	BTFSS	STATUS,Z
	GOTO	NENULA
	MOVF	KOD+1,F
	BTFSC	STATUS,Z
	GOTO	TESTING	; - pokud je to nula, potom preskocime na dalsi ukol
NENULA	MOVLW	D'133'	; - pokud to nula neni, potom hodnotu vysleme na sriovy port 
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	KOD+1,W
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	KOD,W
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	GOTO	READING	; pokracujeme ve cteni...
TESTING	MOVLW	D'1'	; napis: "otestujte prijem"
	CALL	SKRIPT
	CLRF	POZICE	; ukazatel do zaznamu je nastaven na prvni polozku
LOOP2	MOVF	BUFF_STAT,F
	BTFSC	STATUS,Z	; pokud je v bufferu hodnota...
	GOTO	LOOP2
	CALL	OUT_BUFF	; precteme ji...
	MOVWF	KOD+1
	CALL	OUT_BUFF
	MOVWF	KOD
	KRATIT_14	KOD	; !!!zkraceni KODu na 14 bitu!!!
	INTERVAL_	KOD, I1, I2, ADIT_CH	; spocteme tolerancni interval
	CALL	FLRD_REC	; precteme aktualni hodnotu ze zaznamu
	MOVF	KOD,F	; testujeme zda je hodnota nulova
	BTFSS	STATUS,Z
	GOTO	POROVNEJ
	MOVF	KOD+1,F
	BTFSC	STATUS,Z
	GOTO	POZNAL	; - pokud je nulova, znamena to, ze jsme na konci zaznamu a doslo k celkove shode
POROVNEJ			; - v opacnem pripade porovnavame...
	UVNITR_	KOD, I1, I2	
	BTFSS	STATUS,C	; lezi KOD v intervalu?
	CLRF	POZICE	; - pokud ne, resetujeme ukazatel do zaznamu
	GOTO	LOOP2	; - pokud ano, pokracujeme dalsim ctenim a porovnavanim...

POZNAL	MOVLW	D'133'	; kod byl rozpoznan...
	BTFSS	PIR1,TXIF	; ...na port vysleme hodnotu "11111" (dekadicky)
	GOTO	$ - 1
	MOVWF	TXREG
	MOVLW	D'11111' / D'256'
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVLW	D'11111' % D'256'
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVLW	D'2'	; napis: "- OK! -"
	CALL	SKRIPT
	CLRF	POZICE
	GOTO	LOOP2	; opakujeme rozpoznavani

;-------------------------------------------------------------------
; PROGRAMOVE MODULY
	
	; ukladani do bufferu
IN_BUFF	INBUFF_	BUFF_ADR, BUFF_SIZE, BUFF_IN, BUFF_OUT, BUFF_STAT, BUFF_TEMP, 0
	RETURN
	
	; cteni z bufferu (s docasnou deaktivaci preruseni)
OUT_BUFF	OUTBUFF_	BUFF_ADR, BUFF_SIZE, BUFF_IN, BUFF_OUT, BUFF_STAT, BUFF_TEMP, 1
	RETURN

	; zaznam do RAM pameti
IR_REC	IR_REC_	KOD, POZICE, BLOK1, BLOK2, MINKOD, MAXKOD
	RETURN

	; cteni zaznamu z FLASH pameti
FLRD_REC	FLRD_REC_	KOD, POZICE, K_ADR
	RETURN

	;16bitove deleni bez znaminka
DIV16U	DIV16U_M	AA,BB,CC,VD16U 

	;interpret skriptu
SKRIPT	SKRIPT_	TABULKY, PUTZNAK, DPRIKAZ, NUMFORM_, DIV16U, AA, BB, CC
	RETURN

	; obsluha displeje
	DISPLEJ	TMH,TML,DDATA,DB4,DB5,DB6,DB7,E,RW,RS

;------------------------------------------------------------------
; !!!SKRIPTY!!!

TABULKY	DATA	NAPIS1	; indexacni tabulka
	DATA	NAPIS2
	DATA	NAPIS3

NAPIS1	POS_D	D'0'
	DE	"vygenerujte novy"
	POS_D	D'64'
	DE	"!!  IR - kod  !!"
	EOFS
NAPIS2	DRESET
	DE	"otestujte prijem"
	EOFS
NAPIS3	POS_D	D'65'
	DE	"- OK! -"
	EOFS

	END
