;--------------------------------------------;
; TENTO PROGRAM PRIJIMA DATA Z PC-KLAVESNICE ;
;     A K TOMU POUZIVA OBSLUHU PRERUSENI     ;
;   spustte si PC aplikaci, ktera prijima    ;
; data pomoci serioveho portu: KEY_VIEW.EXE  ;
;--------------------------------------------;

	LIST	P = 16F877, R = DEC
	#include	p16f877.inc

	__CONFIG	B'11111100111010'

	#include	unibuff.inc

;---------------------------------------------
;||||||||||| KONSTANTY PROGRAMU ||||||||||||||
;---------------------------------------------

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"
TEMPRAM	EQU	H'70'	; posledni blok pameti (16 bytu)
			; - je zrcadlen do vsech pametovych bank

#DEFINE	CLOCK	PORTB,0	; hodiny z klavesnice jako zdroj preruseni (INTF)
#DEFINE	KEYDATA	PORTB,6	; datovy vodic z klavesnice

BUFF_SIZE	EQU	D'64'	; velikost bufferu pro klavesnici

	CBLOCK	OFFRAM
	BUFF_IN:1	; pro obsluhu bufferu
	BUFF_OUT:1
	BUFF_STAT:1
	BUFF_TEMP:1
	BUFF_ADR:BUFF_SIZE

	KEYCOUNT:1 ; pro praci s PC klavesnici
	KEYKOD:2
	ENDC

	CBLOCK	TEMPRAM	; zalozni registry, ktere
	W_TEMP:1		; jsou nezavisle na zvolene
	ST_TEMP:1		; pametove bance !!!
	FSR_TEMP:1
	ENDC

	ORG	0
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	GOTO	START

	ORG	4
	MOVWF	W_TEMP		; zaloha registru W,STATUS a FSR
	MOVF	STATUS,W
	MOVWF	ST_TEMP
	MOVF	FSR,W
	MOVWF	FSR_TEMP
	banksel	0
	BCF	INTCON,INTF	; vymazani priznaku nabezne hrany
	BTFSS	INTCON,T0IF	; pokud TMR0 pretekl,...
	GOTO	DETEKCE
	MOVLW	D'11'		; ...potom se urcite jedna o prvni bit slova
	MOVWF	KEYCOUNT
DETEKCE	CLRF	TMR0		; resetujeme TMR0
	BCF	INTCON,T0IF
	BCF	KEYKOD+1,3	; pridame bit do vysledneho slova...
	BTFSC	KEYDATA		; ...podle vstupniho pinu z klavesnice
	BSF	KEYKOD+1,3
	RRF	KEYKOD+1,F	; posuneme bity
	RRF	KEYKOD,F
	DECFSZ	KEYCOUNT,F	; pokud byl ziskan posledni (11-ty) bit,...
	GOTO	INT_END
	MOVLW	D'11'		; ...potom resetujeme KEYCOUNT
	MOVWF	KEYCOUNT
	MOVF	KEYKOD+1,W	; zapiseme vysledne slovo do bufferu
	ANDLW	B'00000111'	; (orizneme "smeti")
	CALL	IN_BUFF
	MOVF	KEYKOD,W
	CALL	IN_BUFF
INT_END	MOVF	FSR_TEMP,W	; obnova registru ze zalohy
	MOVWF	FSR
	MOVF	ST_TEMP,W
	MOVWF	STATUS
	SWAPF	W_TEMP,F
	SWAPF	W_TEMP,W
	RETFIE

START	
	banksel	OPTION_REG
	BSF	OPTION_REG,INTEDG	; pin RB0 bude reagovat na nabeznou hranu
	BCF	OPTION_REG,T0CS	; casovani pomoci internich hodin
	BCF	OPTION_REG,PSA	; predelicka predrazena pro TMR0
	BCF	OPTION_REG,2	; nastavime predelicku pro TMR0 na 4:1
	BCF	OPTION_REG,1
	BSF	OPTION_REG,0
	banksel	TRISB	; vstup pro klavesnici
	BSF	CLOCK
	BSF	KEYDATA
	MOVLW	B'00100100'	; nastav vysilac pro...
	banksel	TXSTA		; ...asynchronni 8bitovy prenos
	MOVWF	TXSTA
	MOVLW	B'10010000'	; nastav prijimac pro...
	banksel	RCSTA		; ...asynchronni 8bitovy prijem
	MOVWF	RCSTA
	MOVLW	D'10'		; nastav komunikacni rychlost,...
	banksel	SPBRG		; ...v nasem pripade 115200 baudu
	MOVWF	SPBRG
	banksel	0

	; inicializace bufferu
	BUFFINI 	BUFF_IN, BUFF_OUT,BUFF_STAT

	; preruseni od pinu RB0
	BSF	INTCON,INTE
	BSF	INTCON,GIE

LOOP	MOVF	BUFF_STAT,F
	BTFSC	STATUS,Z	; pokud neni buffer prazdny...
	GOTO	LOOP
	MOVLW	D'133'	; ...potom posleme na TX-port hodnotu 133
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	CALL	OUT_BUFF	; ...potom pecteme z bufferu a posleme na port dva byty
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	CALL	OUT_BUFF
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	GOTO	LOOP	; navrat k testovani bufferu

	; ukladani do bufferu
IN_BUFF	INBUFF_	BUFF_ADR, BUFF_SIZE, BUFF_IN, BUFF_OUT, BUFF_STAT, BUFF_TEMP, 0
	RETURN
	
	; cteni z bufferu
OUT_BUFF	OUTBUFF_	BUFF_ADR, BUFF_SIZE, BUFF_IN, BUFF_OUT, BUFF_STAT, BUFF_TEMP, 1
	RETURN

	END
